;; nagtorus.asm 
;; translation of ntorus.asm in win32nasm package. (used hll macros :)  )

;; regards,
;; mathiisalive@yahoo.com

;; Original code by Serge | (C)hardCode | http://bizarrecreations.webjump.com
;; 

%include "nagoa+.inc"

%include "gl.inc"

;%macro API 2                                   ;Function , Library
;	import %1 %2
;	extern %1
;%endmacro

API GetModuleHandleA, kernel32.dll
API RegisterClassExA, user32.dll
API LoadIconA,user32.dll
API CreateWindowExA, user32.dll
API MessageBoxA, user32.dll
API SendMessageA, user32.dll
API DefWindowProcA, user32.dll
API ExitProcess, kernel32.dll
API GetMessageA, user32.dll
API DispatchMessageA, user32.dll
API TranslateMessage,user32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API PostQuitMessage,user32.dll
API LoadCursorA,user32.dll
API PeekMessageA,user32.dll
API GetCommandLineA,kernel32.dll
API GetClientRect,user32.dll
API InvalidateRect,user32.dll

API GetDC,user32.dll

API GetStockObject,gdi32.dll
API ChoosePixelFormat,gdi32.dll
API SetPixelFormat,gdi32.dll
API wglCreateContext,opengl32.dll
API wglMakeCurrent,opengl32.dll
API wglDeleteContext,opengl32.dll
API glClearColor,opengl32.dll
API glClear,opengl32.dll
API glPushMatrix,opengl32.dll
API glPopMatrix ,opengl32.dll
API glRotatef,opengl32.dll
API glBegin,opengl32.dll
API glEnd,opengl32.dll
API glColor3f,opengl32.dll
API glVertex2f,opengl32.dll
API glViewport,opengl32.dll
API SwapBuffers,gdi32.dll
API glMatrixMode,opengl32.dll
API glFrustum,opengl32.dll
API glLoadIdentity,opengl32.dll
API glTranslatef,opengl32.dll
API glLightfv,opengl32.dll
API glEnable,opengl32.dll
API glShadeModel,opengl32.dll
API glMaterialfv,opengl32.dll
API glMaterialf,opengl32.dll
API BeginPaint,user32.dll
API EndPaint,user32.dll
API glNormal3f,opengl32.dll,
API glVertex3f,opengl32.dll
API glFinish,opengl32.dll
API ReleaseDC,user32.dll

segment .data USE32

Windowclassname db 'OurWindowclass',0
Windowname db 'OpenGL torus for NASM',0

Windowhandle dd 0
Instance dd 0
CommandLine dd 0
glHalf dd 0.5

Roll dd 0
rotstep dd 1.35

light0Pos dd 0.70,0.70,1.25,0.00

mat0_Ambient  dd 0.01,0.01,0.01,1.0
mat0_Diffuse  dd 0.85,0.85,0.2,1.0
mat0_Specular dd 0.5,0.5,0.5,1.0
mat0_Shine    dd 20.0

mat1_Ambient  dd 0.01,0.01,0.01,1.0
mat1_Diffuse  dd 0.05,0.07,0.8,1.0
mat1_Specular dd 0.5,0.5,0.5,1.0
mat1_Shine    dd 20.0


MessageBuffer:
 istruc MSG
 iend

OurWindowclass:
 istruc WNDCLASSEX
	at WNDCLASSEX.cbSize,	dd WNDCLASSEX_size
	at WNDCLASSEX.style, 	dd CS_HREDRAW | CS_VREDRAW
	at WNDCLASSEX.lpfnWndProc, dd winProc
	at WNDCLASSEX.hbrBackground, dd COLOR_GRAYTEXT
	at WNDCLASSEX.lpszMenuName,  dd 0
	at WNDCLASSEX.lpszClassName, dd Windowclassname
 iend

ps:
 istruc PAINTSTRUCT
 iend

pfd:
 istruc PIXELFORMATDESCRIPTOR
 iend
pfdsize equ $-pfd

crect:
 istruc RECT
 iend

section .bss USE32

hDC resd 1 ; GDI device context
hRC resd 1 ; OpenGL rendering context

segment .code USE32 class=code
..start

call GetModuleHandleA,0
mov dword [Instance], eax

call GetCommandLineA
mov dword [CommandLine], eax
loccall WinMain,[Instance], NULL, eax, SW_SHOW

getout:
call ExitProcess, eax


proc WinMain, hInstance, hPrevInstance, lpCmdLine, nCmdShow
	mov eax, dword [@hInstance]
	mov dword [OurWindowclass+WNDCLASSEX.hInstance], eax
	call LoadIconA, NULL, IDI_APPLICATION
	mov dword [OurWindowclass+WNDCLASSEX.hIcon], eax
	mov dword [OurWindowclass+WNDCLASSEX.hIconSm], eax
	call LoadCursorA, NULL, IDC_ARROW
	mov dword [OurWindowclass+WNDCLASSEX.hCursor], eax
	call RegisterClassExA,OurWindowclass
	if eax,e,0
		return
	endif
	
	;--- create and show the main program window
	call CreateWindowExA,NULL,Windowclassname,Windowname,WS_OVERLAPPED|WS_VISIBLE|WS_CAPTION|WS_MINIMIZEBOX |WS_MAXIMIZEBOX|WS_SYSMENU,0,0,512,512, NULL, NULL, [@hInstance], NULL
	mov dword [Windowhandle], eax
	call ShowWindow, [Windowhandle],SW_SHOW
	call UpdateWindow,[Windowhandle]
	
	; -- in order to get all messages imputed by the user 
	while eax,e,eax  ;;infinite loop
		call InvalidateRect,[Windowhandle],0,0 ; force WM_PAINT
		call PeekMessageA,MessageBuffer, NULL, 0, 0,PM_REMOVE      
		if eax,ne,0
			if eax,b,0
				jmp near erro
			endif
			if dword[MessageBuffer+MSG.message],e,WM_QUIT
				jmp near finish
			else
				call TranslateMessage,MessageBuffer
				call DispatchMessageA,MessageBuffer
			endif
		endif
	wend
	
	erro:
	call MessageBoxA, 0, "ERROR", "Sorry ...", MB_OK
	mov eax, dword[MessageBuffer+MSG.wParam]
	finish:
endproc

;;;;Our windows procedure

proc winProc,hWnd,uMsg,wParam,lParam
	if dword[@uMsg],e,WM_CLOSE
		call PostQuitMessage, 0	
		xor eax,eax
		
	elseif dword[@uMsg],e,WM_CREATE
		loccall SetupOpenGL,[@hWnd]
		call GetClientRect,[@hWnd],crect
		loccall GL_Resize,[crect+RECT.right],[crect+RECT.bottom]	

	elseif dword[@uMsg],e,WM_DESTROY
		loccall KillOpenGL,[@hWnd]
		call PostQuitMessage, 0	
		xor eax,eax

	elseif dword[@uMsg],e,WM_SIZE
		if dword [hRC],ne,0
			call GetClientRect,[@hWnd],crect
			loccall GL_Resize, [crect+RECT.right],[crect+RECT.bottom]
 		endif

 	elseif dword[@uMsg],e,WM_KEYDOWN
		if dword[@wParam],e,VK_ESCAPE
			call PostQuitMessage, 0	
			xor eax,eax
		endif

	elseif dword[@uMsg],e,WM_PAINT
		call BeginPaint,[@hWnd],ps
 		loccall GL_Paint
 		call EndPaint,[@hWnd],ps
 	else
		defaultaction:
 		call DefWindowProcA,[@hWnd],[@uMsg],[@wParam],[@lParam]
	endif
endproc

proc GL_Resize,w,h
	stack left,8
	stack right,8 
	stack bottom,8
	stack top,8
		
	fld dword [glHalf]
	fst qword [@right]   ; 0.5
	fst qword [@top]     ; 0.5
	fchs
	fst qword [@left]    ; -0.5
	fstp qword [@bottom] ; -0.5
	_glMatrixMode GL_PROJECTION
	_glLoadIdentity
	fild dword [@w]
	fild dword [@h]
	; take care of aspect ratio
	mov eax,[@w]
	if eax,nbe,[@h]
		fdivp st1,st0  ; w/h
		fld st0
		fmul qword [@right]
		fxch
		fmul qword [@left]
		fstp qword [@left]
		fstp qword [@right]
	else
		fdivrp st1,st0 ; h/w
		fld st0
		fmul qword [@top]
		fxch
		fmul qword [@bottom]
		fstp qword [@bottom]
		fstp qword [@top]
	endif

	_glFrustum @left,@right,@bottom,@top,1.0,3.0
	_glMatrixMode GL_MODELVIEW
	_glViewport 0,0,[@w],[@h]

endproc

proc SetupOpenGL,hWnd

	call GetDC,[@hWnd]
	mov [hDC],eax

	mov word [pfd+PIXELFORMATDESCRIPTOR.nSize],pfdsize
	mov word [pfd+PIXELFORMATDESCRIPTOR.nVersion],1
	mov dword [pfd+PIXELFORMATDESCRIPTOR.dwFlags],PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER | PFD_DRAW_TO_WINDOW
	mov dword [pfd+PIXELFORMATDESCRIPTOR.dwLayerMask],PFD_MAIN_PLANE
	mov byte [pfd+PIXELFORMATDESCRIPTOR.iPixelType],PFD_TYPE_RGBA
	mov byte [pfd+PIXELFORMATDESCRIPTOR.cColorBits],16
	mov byte [pfd+PIXELFORMATDESCRIPTOR.cDepthBits],16
	mov byte [pfd+PIXELFORMATDESCRIPTOR.cAccumBits],0
	mov byte [pfd+PIXELFORMATDESCRIPTOR.cStencilBits],0

	call ChoosePixelFormat,[hDC],pfd

	call SetPixelFormat,[hDC],eax,pfd

	call wglCreateContext,[hDC]
	mov [hRC],eax

	call wglMakeCurrent,[hDC],[hRC]

	; position viewer
	_glMatrixMode GL_MODELVIEW

	_glTranslatef 0.0,0.0,-2.0

	; position light0
	call glLightfv,GL_LIGHT0,GL_POSITION,light0Pos

	_glEnable GL_LIGHTING
	_glEnable GL_LIGHT0
	_glEnable GL_DEPTH_TEST
	_glEnable GL_CULL_FACE
	_glShadeModel GL_SMOOTH
endproc


proc KillOpenGL,hWnd
	 call wglMakeCurrent,0,0
	 call wglDeleteContext,[hRC]
	 call ReleaseDC,[@hWnd],[hDC]
endproc


proc SelectMaterial,matNum
	if dword [@matNum],e,0
		_glMaterialfv GL_FRONT,GL_AMBIENT,mat0_Ambient
		_glMaterialfv GL_FRONT,GL_DIFFUSE,mat0_Diffuse
		_glMaterialfv GL_FRONT,GL_SPECULAR,mat0_Specular
		_glMaterialfv GL_FRONT,GL_SHININESS,mat0_Shine
	else
		_glMaterialfv GL_FRONT,GL_AMBIENT,mat1_Ambient
		_glMaterialfv GL_FRONT,GL_DIFFUSE,mat1_Diffuse
		_glMaterialfv GL_FRONT,GL_SPECULAR,mat1_Specular
		_glMaterialfv GL_FRONT,GL_SHININESS,mat1_Shine
	endif
endproc

proc glTorus,majorRadius,minorRadius,numMajor,numMinor
	stack baseMat,4
	stack majorStep,4,minorStep,4
	stack majcounter,4,mincounter,4
	stack a,4,b,4
	stack sin0,4,cos0,4,sin1,4,cos1,4
	;* normals
	stack n0X,4,n0Y,4,n0Z,4,n1X,4,n1Y,4,n1Z,4
	;* vertices
	stack v0X,4,v0Y,4,v0Z,4,v1X,4,v1Y,4,v1Z,4

	fldpi
	fadd st0,st0
	fld st0
	fidiv dword [@numMinor]
	fxch
	fidiv dword [@numMajor]  ; FPU: majorStep=2PI/numMajor, minorStep=2PI/numMinor
	m2m [@majcounter],[@numMajor]
	fstp dword [@majorStep]
	fstp dword [@minorStep]
    	while dword[@majcounter],ne,0
		mov eax,[@numMajor]
		mov ecx,[@majcounter]
		sub eax,ecx
		push eax
		fild dword [esp]
		fmul dword [@majorStep]
		fld st0
		fadd dword [@majorStep]  ; b,a
		fsincos                      ; cos(b),sin(b),a
		fxch st2                     ; a,sin(b),cos(b)
		fsincos                      ; cos(a),sin(a),sin(b),cos(b),majorStep,minorStep
		pop eax
		and eax,1
		mov [@baseMat],eax
		fstp dword [@cos0]
		fstp dword [@sin0]
		fstp dword [@sin1]
		fstp dword [@cos1]
		_glBegin GL_TRIANGLE_STRIP
		m2m [@mincounter],[@numMinor]
		while dword[@mincounter],ge,0
			mov eax,dword [@numMinor]
			mov ecx,dword [@mincounter]
			sub eax,ecx
			push eax
			fild dword [esp]
			fmul dword [@minorStep]
			fsincos           ; cos(x),sin(x)
			fld st0
			fmul dword [@minorRadius]
			fadd dword [@majorRadius]  ; r=cos(x)*minorRadius+majorRadius,cos(x),sin(x)
			fxch st2
			fmul dword [@minorRadius]  ; z=minorRadius*sin(x),cos(x),r
			fxch                           ; cos(x),z,r
				; calc normals & vertices
			fld st0
			fmul dword [@cos0]
			fstp dword [@n0X]
			fld st0
			fmul dword [@sin0]
			fstp dword [@n0Y]
			fld st0
			fmul dword [@cos1]
			fstp dword [@n1X]
			fmul dword [@sin1]
			fstp dword [@n1Y]
			fst dword [@v0Z]
			fst dword [@v1Z]
			fdiv dword [@minorRadius]
			fst dword [@n0Z]
			fstp dword [@n1Z]
			fld st0
			fmul dword [@cos0]
			fstp dword [@v0X]
			fld st0
			fmul dword [@sin0]
			fstp dword [@v0Y]
			fld st0
			fmul dword [@cos1]
			fstp dword [@v1X]
			fmul dword [@sin1]
			fstp dword [@v1Y]
			pop eax
			and eax,1
			add eax,[@baseMat]
			and eax,1
			loccall SelectMaterial,eax
			_glNormal3f @n0X,@n0Y,@n0Z
			_glVertex3f @v0X,@v0Y,@v0Z
			_glNormal3f @n1X,@n1Y,@n1Z
			_glVertex3f @v1X,@v1Y,@v1Z
			dec dword[@mincounter]
		wend
		call glEnd
		dec dword[@majcounter]
	wend
endproc


proc GL_Paint
	if dword[hRC],ne,0
		;**** clear framebuffer and depth-buffer

		call glClear,GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT
		;**** rotate torus
		call glPushMatrix ; push viewer's matrix
		call glMatrixMode,GL_MODELVIEW
		
		_glRotatef Roll,0.0,1.0,0.0         ; rotate around Y axis

		fld dword [Roll]
		fadd dword [rotstep]
		fstp dword [Roll]

		_glRotatef Roll,1.0,0.0,0.0 ; rotate around X axis

		;**** draw torus
		push dword 24
		push dword 32
		gl_fpush 0.2
		gl_fpush 0.6
		loccall glTorus

		;**** finish
		call glPopMatrix
		call glFinish

		call SwapBuffers,[hDC]
	endif
 endproc
